Rem
Rem	Create_Order_Entry.sql
Prompt ******** CREATE ORDER ENTRY STRUCTURE ********
Rem
Rem Studi Kasus melibatkan 6 tabel yaitu Vendors, Products, ProductNotes, Customers, Orders, OrderItems
Rem
Rem ****************************************
Rem Buat table CUSTOMERS yang menyimpan data Customer
Rem Primary Key adalah cust_id

Prompt ******** Buat Table CUSTOMERS ********
CREATE TABLE customers
(
  cust_id      CHAR(5)       NOT NULL,
  cust_name    VARCHAR2(25)  NOT NULL ,
  cust_address VARCHAR2(30)  NULL ,
  cust_city    VARCHAR2(25)  NULL ,
  cust_state   VARCHAR2(5)   NULL ,
  cust_zip     VARCHAR2(5)   NULL ,
  cust_country VARCHAR2(20)  NULL ,
  cust_contact VARCHAR2(25)  NULL ,
  cust_email   VARCHAR2(30)  NULL
);
ALTER TABLE customers
ADD CONSTRAINT pk_customers PRIMARY KEY (cust_id);

Rem 
Rem ****************************************
Rem Buat table ORDERITEMS yang menyimpan data Detil Pemesanan Barang
Rem Primary Key adalah order_num & order_item
Rem Foreign Key adalah order_num & prod_id

Prompt ******** Buat Table ORDERITEMS ********
CREATE TABLE orderitems
(
  order_num  NUMBER(5,0)  NOT NULL ,
  order_item NUMBER       NOT NULL ,
  prod_id    VARCHAR2(10) NOT NULL ,
  quantity   NUMBER(3,0)  NOT NULL 
);
ALTER TABLE orderitems
ADD CONSTRAINT pk_orderitems PRIMARY KEY (order_num, order_item);

Rem 
Rem ****************************************
Rem Buat table ORDERS yang menyimpan data Pemesanan Barang
Rem Primary Key adalah order_num 
Rem Foreign Key adalah cust_id

Prompt ******** Buat Table ORDERS ********
CREATE TABLE orders
(
  order_num  NUMBER(5,0) NOT NULL,
  order_date DATE        NOT NULL,
  cust_id    CHAR(5)     NOT NULL
);
ALTER TABLE orders
ADD CONSTRAINT pk_orders PRIMARY KEY (order_num);

Rem 
Rem ****************************************
Rem Buat table PRODUCTS yang menyimpan data Barang
Rem Primary Key adalah prod_id 
Rem Foreign Key adalah vend_id

Prompt ******** Buat Table PRODUCTS ********
CREATE TABLE products
(
  prod_id    VARCHAR2(10)  NOT NULL,
  vend_id    CHAR(4)       NOT NULL ,
  prod_name  VARCHAR2(25)  NOT NULL ,
  prod_price NUMBER(12,0)  NOT NULL ,
  prod_desc  VARCHAR2(255) NULL
);
ALTER TABLE products
ADD CONSTRAINT pk_products PRIMARY KEY (prod_id);

Rem 
Rem ****************************************
Rem Buat table VENDORS yang menyimpan data Barang
Rem Primary Key adalah vend_id 

Prompt ******** Buat Table VENDORS ********
CREATE TABLE vendors
(
  vend_id      CHAR(4)      NOT NULL,
  vend_name    VARCHAR2(25) NOT NULL,
  vend_address VARCHAR2(30) NULL,
  vend_city    VARCHAR2(20) NULL,
  vend_state   VARCHAR2(5)  NULL,
  vend_zip     VARCHAR2(7)  NULL,
  vend_country VARCHAR2(15) NULL
);
ALTER TABLE vendors
ADD CONSTRAINT pk_vendors PRIMARY KEY (vend_id);

Rem 
Rem ****************************************
Rem Buat table PRODUCTNOTES yang menyimpan data Keterangan barang
Rem Primary Key adalah note_id
Rem Foreign Key adalah prod_id

Prompt ******** Buat Table PRODUCTNOTES ********
CREATE TABLE productnotes
(
  note_id    CHAR(3)        NOT NULL,
  prod_id    VARCHAR2(10)   NOT NULL,
  note_date  DATE           NOT NULL,
  note_text  VARCHAR2(200)  NULL
);
ALTER TABLE productnotes
ADD CONSTRAINT pk_productnotes PRIMARY KEY (note_id);

Rem 
Rem ****************************************
Rem mendefinisikan FOREIGN KEYS

Prompt ******** BUAT FOREIGN KEYS ********
ALTER TABLE orderitems 
 ADD CONSTRAINT fk_orderitems_orders 
 FOREIGN KEY (order_num) REFERENCES orders (order_num);

ALTER TABLE orderitems 
 ADD CONSTRAINT fk_orderitems_products 
 FOREIGN KEY (prod_id) REFERENCES products (prod_id);

ALTER TABLE orders 
 ADD CONSTRAINT fk_orders_customers 
 FOREIGN KEY (cust_id) REFERENCES customers (cust_id);

ALTER TABLE products 
 ADD CONSTRAINT fk_products_vendors 
 FOREIGN KEY (vend_id) REFERENCES vendors (vend_id);
 
ALTER TABLE productnotes 
 ADD CONSTRAINT fk_productnotes_products 
 FOREIGN KEY (prod_id) REFERENCES products (prod_id);
